Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/LoopExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/LoopExpression.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/LoopExpression.cs	(revision 14513)
@@ -1,121 +1,93 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
-using HeuristicLab.Common;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class LoopExpression : StatefullExpression
-    {
-        protected long destinationIndex;
-        protected long currentIndex;
-        protected long incrementor;
-        protected Expression body;
+  public class LoopState {
+    public Expression Body;
+    public long CurrentIndex;
+    public long DestinationIndex;
+    public long Incrementor;
+  }
 
-        public LoopExpression()
-        { }
+  public abstract class LoopExpression : StatefullExpression<LoopState> {
+    protected LoopExpression() : base(new LoopState()) { }
 
-        /// <summary>
-        /// Clone constructor
-        /// </summary>
-        protected LoopExpression(LoopExpression origin, Cloner cloner) : base(origin, cloner)
-        {
-            destinationIndex = origin.destinationIndex;
-            currentIndex = origin.currentIndex;
-            incrementor = origin.incrementor;
-            body = origin.body;
-        }
+    protected void Eval(IPushGpInterpreter interpreter, IStack<Expression> sourceStack, bool pushCurrentIndex = false) {
+      // if not initialized
+      if (this.State.Body == null) {
+        if (this.HasInsufficientArguments(interpreter, sourceStack)) return;
 
-        protected void Eval(IInterpreter interpreter, IStack<Expression> sourceStack, bool pushCurrentIndex = false)
-        {
-            // if not initialized
-            if (body == null)
-            {
-                if (HasInsufficientArguments(interpreter, sourceStack))
-                {
-                    return;
-                }
+        this.InitState(interpreter, sourceStack);
 
-                InitState(interpreter, sourceStack);
+        interpreter.ExecStack.Push(this, this.State.Body);
 
-                interpreter.ExecStack.Push(this, body);
+        return;
+      }
 
-                return;
-            }
+      // if loop end reached
+      if (this.State.DestinationIndex == this.State.CurrentIndex) {
+        this.PushLastIteration(interpreter);
+        this.Clear();
 
-            // if loop end reached
-            if (destinationIndex == currentIndex)
-            {
-                PushLastIteration(interpreter);
-                Clear();
+        return;
+      }
 
-                return;
-            }
+      this.PushIteration(interpreter);
+      this.State.CurrentIndex += this.State.Incrementor;
+    }
 
-            PushIteration(interpreter);
-            currentIndex += incrementor;
-        }
+    protected virtual void Clear() {
+      this.State.Body = null;
+    }
 
-        protected virtual void Clear()
-        {
-            body = null;
-        }
+    protected virtual void PushIteration(IPushGpInterpreter interpreter) {
+      interpreter.IntegerStack.Push(this.State.CurrentIndex);
+      interpreter.ExecStack.Push(this, this.State.Body);
+    }
 
-        protected virtual void PushIteration(IInterpreter interpreter)
-        {
-            interpreter.IntegerStack.Push(currentIndex);
-            interpreter.ExecStack.Push(this, body);
-        }
+    protected virtual void PushLastIteration(IPushGpInterpreter interpreter) {
+      interpreter.IntegerStack.Push(this.State.CurrentIndex);
+      interpreter.ExecStack.Push(this.State.Body);
+    }
 
-        protected virtual void PushLastIteration(IInterpreter interpreter)
-        {
-            interpreter.IntegerStack.Push(currentIndex);
-            interpreter.ExecStack.Push(body);
-        }
+    public override bool Equals(object obj) {
+      if (!base.Equals(obj)) return false;
 
-        public override bool Equals(object obj)
-        {
-            if (!base.Equals(obj))
-            {
-                return false;
-            }
+      var other = obj as LoopExpression;
 
-            var other = obj as LoopExpression;
+      var isBodyEqual = ((this.State.Body == null) && (other.State.Body == null))
+                        || (this.State.Body != null && this.State.Body.Equals(other.State.Body));
 
-            var isBodyEqual =
-                (body == null && other.body == null) ||
-                (body != null && other.body != null && body.Equals(other.body));
+      return isBodyEqual && (this.State.CurrentIndex == other.State.CurrentIndex)
+             && (this.State.DestinationIndex == other.State.DestinationIndex) && (this.State.Incrementor == other.State.Incrementor);
+    }
 
-            return isBodyEqual &&
-                currentIndex == other.currentIndex &&
-                destinationIndex == other.destinationIndex &&
-                incrementor == other.incrementor;
-        }
+    public override string ToString() {
+      return this.StringRepresentation;
+    }
 
-        public override int GetHashCode()
-        {
-            return base.GetHashCode();
-        }
+    public override int GetHashCode() {
+      return base.GetHashCode();
+    }
 
-        protected override int InitId()
-        {
-            unchecked
-            {
-                var hash = 19;
+    protected override int InitId() {
+      unchecked {
+        var hash = 19;
 
-                if (body != null)
-                {
-                    hash *= 31 + body.GetHashCode();
-                }
+        hash = hash * 31 + this.GetType().GetHashCode();
 
-                hash *= 31 + currentIndex.GetHashCode();
-                hash *= 31 + destinationIndex.GetHashCode();
-                hash *= 31 + incrementor.GetHashCode();
+        if ((this.State.Body != null) && (this.State.Body != this)) hash = hash * 31 + this.State.Body.GetHashCode();
 
-                return hash;
-            }
-        }
+        hash = hash * 31 + this.State.CurrentIndex.GetHashCode();
+        hash = hash * 31 + this.State.DestinationIndex.GetHashCode();
+        hash = hash * 31 + this.State.Incrementor.GetHashCode();
 
-        protected abstract bool HasInsufficientArguments(IInterpreter interpreter, IStack<Expression> sourceStack);
-        protected abstract void InitState(IInterpreter interpreter, IStack<Expression> sourceStack);
+        return hash;
+      }
     }
+
+    protected abstract bool HasInsufficientArguments(IPushGpInterpreter interpreter, IStack<Expression> sourceStack);
+
+    protected abstract void InitState(IPushGpInterpreter interpreter, IStack<Expression> sourceStack);
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/NameExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/NameExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/NameExpressions.cs	(revision 14513)
@@ -1,112 +1,85 @@
-﻿using System;
-using System.Linq;
-using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Random;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using System.Linq;
+  using System.Threading;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public class NameDefineXExecExpression : StatefullExpression
-    {
-        private readonly string name;
-        public NameDefineXExecExpression(string name)
-        {
-            this.name = name;
-        }
+  using HeuristicLab.Algorithms.PushGP.Data.Random;
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Core;
 
-        public NameDefineXExecExpression(NameDefineXExecExpression origin, Cloner cloner) : base(origin, cloner)
-        {
-            name = origin.name;
-        }
+  public class NameDefineXExecExpression : StatefullExpression<string> {
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Expression expression;
-            if (!interpreter.IsNameQuoteFlagSet &&
-                interpreter.CustomExpressions.TryGetValue(name, out expression))
-            {
-                interpreter.ExecStack.Push(expression);
-            }
-            else
-            {
-                interpreter.NameStack.Push(name);
-                interpreter.IsNameQuoteFlagSet = false;
-            }
-        }
+    public NameDefineXExecExpression(string state) : base(state) { }
 
-        public override bool Equals(object obj)
-        {
-            if (!base.Equals(obj))
-            {
-                return false;
-            }
-
-            var other = obj as NameDefineXExecExpression;
-
-            return name.Equals(other.name);
-        }
-
-        public override int GetHashCode()
-        {
-            return base.GetHashCode();
-        }
-
-        protected override string InitStringRepresentation()
-        {
-            return name;
-        }
-
-        protected override int InitId()
-        {
-            return name.GetHashCode();
-        }
-
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            throw new NotImplementedException();
-        }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      Expression expression;
+      if (!interpreter.IsNameQuoteFlagSet && interpreter.CustomExpressions.TryGetValue(this.State, out expression)) {
+        interpreter.ExecStack.Push(expression);
+      } else {
+        interpreter.NameStack.Push(this.State);
+        interpreter.IsNameQuoteFlagSet = false;
+      }
     }
 
-    /// <summary>
-    /// Sets a flag indicating that the next name encountered will be pushed onto the NAME stack (and not have its associated value
-    /// pushed onto the EXEC stack), regardless of whether or not it has a definition. Upon encountering such a name and pushing it
-    /// onto the NAME stack the flag will be cleared (whether or not the pushed name had a definition).
-    /// </summary>
-    public class NameQuoteExpression : StatelessExpression
-    {
-        protected override string InitStringRepresentation()
-        {
-            return "NAME.QUOTE";
-        }
+    public override bool Equals(object obj) {
+      if (!base.Equals(obj)) return false;
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            interpreter.IsNameQuoteFlagSet = true;
-        }
+      var other = obj as NameDefineXExecExpression;
+
+      return this.State.Equals(other.State);
     }
 
-    /// <summary>
-    /// Pushes a randomly selected NAME that already has a definition.
-    /// </summary>
-    public class NameRandBoundNameExpression : StatelessExpression
-    {
-        private static IRandom rand = new FastRandom();
+    public override int GetHashCode() {
+      return base.GetHashCode();
+    }
 
-        protected override string InitStringRepresentation()
-        {
-            return "NAME.RANDBOUNDNAME";
-        }
+    protected override string InitStringRepresentation() {
+      return this.State;
+    }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            if (!interpreter.CustomExpressions.Any())
-                return;
+    protected override int InitId() {
+      var hash = 19;
 
-            var index = rand.Next(0, interpreter.CustomExpressions.Keys.Count - 1);
-            var name = interpreter.CustomExpressions.Keys.ElementAt(index);
+      hash = hash * 31 + this.GetType().GetHashCode();
+      hash = hash * 31 + this.State.GetHashCode();
 
-            interpreter.NameStack.Push(name);
-        }
+      return hash;
     }
+  }
+
+  /// <summary>
+  ///     Sets a flag indicating that the next State encountered will be pushed onto the NAME stack (and not have its
+  ///     associated value
+  ///     pushed onto the EXEC stack), regardless of whether or not it has a definition. Upon encountering such a State and
+  ///     pushing it
+  ///     onto the NAME stack the flag will be cleared (whether or not the pushed State had a definition).
+  /// </summary>
+  public class NameQuoteExpression : StatelessExpression {
+    protected override string InitStringRepresentation() {
+      return "NAME.QUOTE";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      interpreter.IsNameQuoteFlagSet = true;
+    }
+  }
+
+  /// <summary>
+  ///     Pushes a randomly selected NAME that already has a definition.
+  /// </summary>
+  public class NameRandBoundNameExpression : StatelessExpression {
+    private static readonly ThreadLocal<IRandom> Rand = RandomFactory.GetRandom();
+
+    protected override string InitStringRepresentation() {
+      return "NAME.RANDBOUNDNAME";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      if (!interpreter.CustomExpressions.Any()) return;
+
+      var index = Rand.Value.Next(0, interpreter.CustomExpressions.Keys.Count - 1);
+      var state = interpreter.CustomExpressions.Keys.ElementAt(index);
+
+      interpreter.NameStack.Push(state);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PopExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PopExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PopExpressions.cs	(revision 14513)
@@ -1,76 +1,93 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class PopExpression<T> : StatelessExpression
+  public abstract class PopExpression<T> : StatelessExpression
+  {
+    public void Eval(IStack<T> stack)
     {
-        public void Eval(IStack<T> stack)
-        {
-            if (stack.Count == 0)
-                return;
+      if (stack.Count == 0) return;
 
-            stack.Pop();
-        }
+      stack.Pop();
+    }
+  }
+
+  public class IntegerPopExpression : PopExpression<long>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "INTEGER.POP";
     }
 
-    public class IntegerPopExpression : PopExpression<long>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "INTEGER.POP"; }
+      this.Eval(interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack);
-        }
+  public class FloatPopExpression : PopExpression<double>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "FLOAT.POP";
     }
 
-    public class FloatPopExpression : PopExpression<double>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "FLOAT.POP"; }
+      this.Eval(interpreter.FloatStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack);
-        }
+  public class BooleanPopExpression : PopExpression<bool>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "BOOLEAN.POP";
     }
 
-    public class BooleanPopExpression : PopExpression<bool>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "BOOLEAN.POP"; }
+      this.Eval(interpreter.BooleanStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack);
-        }
+  public class NamePopExpression : PopExpression<string>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "NAME.POP";
     }
 
-    public class NamePopExpression : PopExpression<string>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "NAME.POP"; }
+      this.Eval(interpreter.NameStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack);
-        }
+  public class ExecPopExpression : PopExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "EXEC.POP";
     }
 
-    public class ExecPopExpression : PopExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "EXEC.POP"; }
+      this.Eval(interpreter.ExecStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack);
-        }
+  public class CodePopExpression : PopExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "CODE.POP";
     }
 
-    public class CodePopExpression : PopExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "CODE.POP"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.CodeStack);
-        }
+      this.Eval(interpreter.CodeStack);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushExpressions.cs	(revision 14513)
@@ -1,154 +1,103 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
-using HeuristicLab.Common;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class PushExpression<T> : StatefullExpression
-    {
-        protected readonly T value;
+  public abstract class PushExpression<T> : StatefullExpression<T> {
 
-        public PushExpression(T value)
-        {
-            this.value = value;
-        }
+    protected PushExpression(T state) : base(state) { }
 
-        // copy constructor
-        public PushExpression(PushExpression<T> expression, Cloner cloner) : base(expression, cloner)
-        {
-            value = expression.value;
-        }
+    protected override int InitId() {
+      var hash = 19;
 
-        protected override int InitId()
-        {
-            return this.value.GetHashCode();
-        }
+      hash = hash * 31 + this.GetType().GetHashCode();
+      hash = hash * 31 + this.State.GetHashCode();
 
-        protected override string InitStringRepresentation()
-        {
-            return this.value.ToString();
-        }
-
-        protected void Eval(IStack<T> stack)
-        {
-            stack.Push(value);
-        }
-
-        public override bool Equals(object obj)
-        {
-            if (obj == null || !(obj is PushExpression<T>))
-            {
-                return false;
-            }
-
-            var other = obj as PushExpression<T>;
-
-            return value.Equals(value);
-        }
-
-        public override int GetHashCode()
-        {
-            return base.GetHashCode();
-        }
+      return hash;
     }
 
-    public class IntegerPushExpression : PushExpression<long>
-    {
-        public IntegerPushExpression(long value) : base(value)
-        { }
-
-        // copy constructor
-        public IntegerPushExpression(IntegerPushExpression expression, Cloner cloner) : base(expression, cloner)
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack);
-        }
-
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new IntegerPushExpression(this, cloner);
-        }
+    protected void Eval(IStack<T> stack) {
+      stack.Push(this.State);
     }
 
-    public class FloatPushExpression : PushExpression<double>
-    {
-        public FloatPushExpression(double value) : base(value)
-        { }
+    public override bool Equals(object obj) {
+      if (!(obj is PushExpression<T>)) return false;
+      var other = (PushExpression<T>)obj;
 
-        // copy constructor
-        public FloatPushExpression(FloatPushExpression expression, Cloner cloner) : base(expression, cloner)
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack);
-        }
-
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new FloatPushExpression(this, cloner);
-        }
+      return this.State.Equals(other.State);
     }
 
-    public class BooleanPushExpression : PushExpression<bool>
-    {
-        public BooleanPushExpression(bool value) : base(value)
-        { }
+    public override int GetHashCode() {
+      return base.GetHashCode();
+    }
+  }
 
-        // copy constructor
-        public BooleanPushExpression(BooleanPushExpression expression, Cloner cloner) : base(expression, cloner)
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack);
-        }
-
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new BooleanPushExpression(this, cloner);
-        }
+  public class IntegerPushExpression : PushExpression<long> {
+    public IntegerPushExpression(long state)
+      : base(state) {
     }
 
-    public class NamePushExpression : PushExpression<string>
-    {
-        public NamePushExpression(string value) : base(value)
-        { }
-
-        // copy constructor
-        public NamePushExpression(NamePushExpression expression, Cloner cloner) : base(expression, cloner)
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack);
-        }
-
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new NamePushExpression(this, cloner);
-        }
+    protected override string InitStringRepresentation() {
+      return "IntegerPush";
     }
 
-    public class ExecPushExpression : PushExpression<Expression>
-    {
-        public ExecPushExpression(Expression value) : base(value)
-        { }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.IntegerStack);
+    }
+  }
 
-        // copy constructor
-        public ExecPushExpression(ExecPushExpression expression, Cloner cloner) : base(expression, cloner)
-        { }
+  public class FloatPushExpression : PushExpression<double> {
+    public FloatPushExpression(double state)
+      : base(state) {
+    }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack);
-        }
+    protected override string InitStringRepresentation() {
+      return "FloatPush";
+    }
 
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new ExecPushExpression(this, cloner);
-        }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.FloatStack);
     }
+  }
+
+  public class BooleanPushExpression : PushExpression<bool> {
+    public BooleanPushExpression(bool state)
+      : base(state) {
+    }
+
+    protected override string InitStringRepresentation() {
+      return "BooleanPush";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.BooleanStack);
+    }
+  }
+
+  public class NamePushExpression : PushExpression<string> {
+    public NamePushExpression(string state)
+      : base(state) {
+    }
+
+    protected override string InitStringRepresentation() {
+      return "NamePush";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.NameStack);
+    }
+  }
+
+  public class ExecPushExpression : PushExpression<Expression> {
+    public ExecPushExpression(Expression state)
+      : base(state) {
+    }
+
+    protected override string InitStringRepresentation() {
+      return "ExecPush";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.ExecStack);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushResultExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushResultExpression.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushResultExpression.cs	(revision 14513)
@@ -1,35 +1,28 @@
-﻿using System;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using System;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class PushResultExpression<T> : StatelessExpression
-    {
-        protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc)
-        {
-            if (stack.Count < count)
-                return;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-            stack.PushResult(count, templateFunc);
-        }
+  public abstract class PushResultExpression<T> : StatelessExpression {
+    protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc) {
+      if (stack.Count < count) return;
 
-        protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc, T ignoreValue)
-        {
-            if (stack.Count < count || stack.Top.Equals(ignoreValue))
-                return;
+      stack.PushResult(count, templateFunc);
+    }
 
-            stack.PushResult(count, templateFunc);
-        }
+    protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc, T ignoreValue) {
+      if ((stack.Count < count) || stack.Top.Equals(ignoreValue)) return;
 
-        protected void Eval<R>(IStack<T> stack, IStack<R> resultStack, int count, Func<T[], R> templateFunc)
-        {
-            if (stack.Count < count)
-                return;
+      stack.PushResult(count, templateFunc);
+    }
 
-            var items = stack.Pop(count);
-            var result = templateFunc(items);
+    protected void Eval<R>(IStack<T> stack, IStack<R> resultStack, int count, Func<T[], R> templateFunc) {
+      if (stack.Count < count) return;
 
-            resultStack.Push(result);
-        }
+      var items = stack.Pop(count);
+      var result = templateFunc(items);
+
+      resultStack.Push(result);
     }
+  }
 }
